/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swinghouseplan;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.util.Enumeration;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author naksabi
 */
class SwingHousePlanFrame extends JFrame {
    private DefaultListModel<Room> roomsModel = new DefaultListModel<>();
    private ListSelectionListener roomSelectionListener = new ListSelectionListener() {

        @Override
        public void valueChanged(ListSelectionEvent e) {
            Room selectedRoom = getSelectedRoom();
            if(getSelectedRoom() != null){
                selectedRoomX.removeChangeListener(spinnerChangeListener);
                selectedRoomY.removeChangeListener(spinnerChangeListener);
                selectedRoomWidth.removeChangeListener(spinnerChangeListener);
                selectedRoomLength.removeChangeListener(spinnerChangeListener);
                selectedRoomX.setValue(selectedRoom.getX());
                selectedRoomY.setValue(selectedRoom.getY());
                selectedRoomWidth.setValue(selectedRoom.getWidth());
                selectedRoomLength.setValue(selectedRoom.getLength());
                selectedRoomX.addChangeListener(spinnerChangeListener);
                selectedRoomY.addChangeListener(spinnerChangeListener);
                selectedRoomWidth.addChangeListener(spinnerChangeListener);
                selectedRoomLength.addChangeListener(spinnerChangeListener);                
            }
        }
    };
    private ChangeListener spinnerChangeListener = new ChangeListener() {

        @Override
        public void stateChanged(ChangeEvent e) {
            Room selectedRoom = getSelectedRoom();
           if(selectedRoom != null){
               selectedRoom.setX((int) selectedRoomX.getValue());
               selectedRoom.setY((int) selectedRoomY.getValue());
               selectedRoom.setWidth((int) selectedRoomWidth.getValue());
               selectedRoom.setLength((int) selectedRoomLength.getValue());
               repaint();
           }
        }
    };

    public SwingHousePlanFrame() {
        setTitle("Ház alaprajz");
        setLocation(32,24);
        setSize(800,600);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        // Default a BorderLayout()
        setLayout(new BorderLayout());
        
        add(new JPanel(){
           
            @Override
            public void paint(Graphics g){
                paintHousePlan(g);
            }
        }, BorderLayout.CENTER);
       
        roomsList = new JList<>();
        roomsList.setPreferredSize(new Dimension(200,25));
        roomsList.setModel(roomsModel);
        // Csak 1 elemet lehessen kiválasztani a listából egyszerre
        roomsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        roomsList.addListSelectionListener(roomSelectionListener);
        add(new JScrollPane(roomsList),BorderLayout.WEST);
        
        JPanel jPanel = new JPanel();
        //GridLayout --> Táblázatos megjelenítés
        jPanel.setLayout(new GridLayout(2,4));
        jPanel.add(new JLabel("x koord"));
        jPanel.add(new JLabel("y koord"));
        jPanel.add(new JLabel("szélesség"));
        jPanel.add(new JLabel("hosszúság"));
        
        
        
        add(jPanel, BorderLayout.SOUTH);
        
        roomsModel.addElement(new Room(10,10,140,60,"Szoba1"));
        roomsModel.addElement(new Room(150,10,40,60,"Szoba2"));
        roomsModel.addElement(new Room(10,70,180,30,"Szoba3"));
        
        selectedRoomX = new JSpinner(new SpinnerNumberModel(0,0,1000,1));
        selectedRoomY = new JSpinner(new SpinnerNumberModel(0,0,800,1));
        selectedRoomWidth = new JSpinner(new SpinnerNumberModel(0,0,400,1));
        selectedRoomLength = new JSpinner(new SpinnerNumberModel(0,0,300,1));
        
        jPanel.add(selectedRoomX);
        jPanel.add(selectedRoomY);
        jPanel.add(selectedRoomWidth);
        jPanel.add(selectedRoomLength);
        
        selectedRoomX.addChangeListener(spinnerChangeListener);
        selectedRoomY.addChangeListener(spinnerChangeListener);
        selectedRoomWidth.addChangeListener(spinnerChangeListener);
        selectedRoomLength.addChangeListener(spinnerChangeListener);
        
    }
    private JList<Room> roomsList;
    
    private JSpinner selectedRoomX, selectedRoomY, selectedRoomWidth, selectedRoomLength;
    
    private void paintHousePlan(Graphics g) {
        Enumeration<Room> elements = roomsModel.elements();
        while (elements.hasMoreElements()) {
            Room room = elements.nextElement();
            g.drawRect(room.getX(), room.getY(), room.getWidth(), room.getLength());
            // szoba nevének rárajzolása
            g.drawString(room.getName(), room.getX()+2, room.getY()+12);
        }
    }  
    
    public Room getSelectedRoom(){
        return roomsList.getSelectedValue();
    }
    
}
